## vvenc-dmo 1.14.0

=== CMakeLists.txt ===
# Top level CMakeLists.txt
#
# minimum required cmake version
cmake_minimum_required( VERSION 3.13.0 FATAL_ERROR )

# set cmake policy
if( NOT CMAKE_VERSION VERSION_LESS 3.13.0 )
  # Use latest policy
  cmake_policy( VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} )
endif()

# project name
project( vvenc VERSION 1.14.0 )

# set alternative version numbering for release candidates
#set( PROJECT_VERSION_RC rc1 )
if( PROJECT_VERSION_RC )
    set( PROJECT_VERSION "${PROJECT_VERSION}-${PROJECT_VERSION_RC}" )
endif()

set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules" )
message( STATUS "CMAKE_MODULE_PATH: updating module path to: ${CMAKE_MODULE_PATH}" )

include( vvencCompilerSupport )

detect_target_architecture( VVENC_TARGET_ARCH )
if( VVENC_TARGET_ARCH MATCHES "ARM\|AARCH64" )
  set( VVENC_ARM_SIMD_DEFAULT TRUE )

  # Avoid non-portable type casting in Arm vector kernels.
  if( CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
    set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-lax-vector-conversions" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-lax-vector-conversions" )
  endif()

  # Check if SVE/SVE2 flags are supported by the compiler.
  set_if_compiler_supports_arm_extensions( FLAG_sve FLAG_sve2 )
endif()

if( VVENC_TARGET_ARCH MATCHES "LOONGARCH64" )
  set( VVENC_LOONGARCH64_SIMD_DEFAULT TRUE )

  if( CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=lld")
  endif()
endif()

# We enable x86 intrinsics for all target architectures, because they are implemented through SIMD-everywhere on non-x86.
set( VVENC_ENABLE_X86_SIMD TRUE                      CACHE BOOL "Enable x86 intrinsics" )
set( VVENC_ENABLE_ARM_SIMD ${VVENC_ARM_SIMD_DEFAULT} CACHE BOOL "Enable Arm Neon intrinsics" )
set( VVENC_ENABLE_ARM_SIMD_SVE ${FLAG_sve}           CACHE BOOL "Enable Arm SVE intrinsics" )
set( VVENC_ENABLE_ARM_SIMD_SVE2 FALSE                CACHE BOOL "Enable Arm SVE2 intrinsics" )
set( VVENC_ENABLE_LOONGARCH64_SIMD_LSX ${VVENC_LOONGARCH64_SIMD_DEFAULT} CACHE BOOL "Enable LoongArch64 LSX intrinsics" )
set( VVENC_FFP_CONTRACT_OFF OFF                      CACHE BOOL "Disable floating point expression contraction fFr exact math" )

set( VVENC_ENABLE_UNSTABLE_API            OFF        CACHE BOOL "Enable unstable API" )

# Avoid non-portable fp contractions leading to cross-platform bit-differences.
if ( VVENC_FFP_CONTRACT_OFF )
  if( CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR
      CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
    set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffp-contract=off" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffp-contract=off" )
  endif()
endif()

check_problematic_compiler( VVENC_PROBLEMATIC_COMPILER "MSVC" 19.38 19.39 )
if( VVENC_PROBLEMATIC_COMPILER )
  set( VVENC_OVERRIDE_COMPILER_CHECK      OFF        CACHE BOOL "Build with known problematic compiler version" )

  if( VVENC_OVERRIDE_COMPILER_CHECK )
    set( VVENC_PROBLEMATIC_COMPILER_MSG_TYPE     WARNING )
    set( VVENC_PROBLEMATIC_COMPILER_MSG_OVERRIDE
         "The performance will not be optimal due to workarounds." )
  else()
    set( VVENC_PROBLEMATIC_COMPILER_MSG_TYPE FATAL_ERROR )
    set( VVENC_PROBLEMATIC_COMPILER_MSG_OVERRIDE
         "Set -DVVENC_OVERRIDE_COMPILER_CHECK=ON to build with this compiler anyways, which enables workarounds impacting performance.")
  endif()

  message( ${VVENC_PROBLEMATIC_COMPILER_MSG_TYPE}
          "Binaries compiled with ${CMAKE_CXX_COMPILER} version ${CMAKE_CXX_COMPILER_VERSION} are known not to behave as intended. "
          "The problematic version range is ${VVENC_PROBLEMATIC_COMPILER_VERSION_RANGE}. Please consider using a different compiler.\n"
          ${VVENC_PROBLEMATIC_COMPILER_MSG_OVERRIDE} )
endif()

set( VVENC_USE_UNSTABLE_API 0 )
if( VVENC_ENABLE_UNSTABLE_API )
  set( VVENC_USE_UNSTABLE_API 1 )
endif()
configure_file( include/vvenc/vvenc.h.in ${CMAKE_BINARY_DIR}/vvenc/vvenc.h @ONLY )

# enable sse4.1 build for all source files for gcc and clang
if( VVENC_ENABLE_X86_SIMD )
  if( NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Emscripten" )
    check_missing_intrinsics()
  endif()

  message( STATUS "x86 SIMD intrinsics enabled (using SIMDE for non-x86 targets)" )
  add_compile_definitions( TARGET_SIMD_X86=1 )
endif()

if( VVENC_TARGET_ARCH STREQUAL "AARCH64" )
  if( VVENC_ENABLE_ARM_SIMD )
    message( STATUS "AArch64 Neon intrinsics enabled" )
    add_compile_definitions( TARGET_SIMD_ARM=1 )
  endif()

  # If Neon is disabled or SVE is not supported, make sure that SVE is disabled.
  if ( NOT VVENC_ENABLE_ARM_SIMD OR NOT FLAG_sve )
    message( STATUS "Disabling AArch64 SVE/SVE2 intrinsics" )
    set( VVENC_ENABLE_ARM_SIMD_SVE FALSE )
  elseif( VVENC_ENABLE_ARM_SIMD_SVE )
    message( STATUS "AArch64 SVE intrinsics enabled" )
    add_compile_definitions( TARGET_SIMD_ARM_SVE=1 )
  endif()

  # If SVE is disabled or SVE2 is not supported, make sure that SVE2 is disabled.
  if ( NOT VVENC_ENABLE_ARM_SIMD_SVE OR NOT FLAG_sve2 )
    message( STATUS "Disabling AArch64 SVE2 intrinsics" )
    # If SVE is disabled make sure that SVE2 are also disabled.
    set( VVENC_ENABLE_ARM_SIMD_SVE2 FALSE )
  elseif( VVENC_ENABLE_ARM_SIMD_SVE2 )
    message( STATUS "AArch64 SVE2 intrinsics enabled" )
    add_compile_definitions( TARGET_SIMD_ARM_SVE2=1 )
  endif()
endif()

if( VVENC_TARGET_ARCH STREQUAL "ARM" )
  if( VVENC_ENABLE_ARM_SIMD )
    message( STATUS "Arm Neon intrinsics enabled" )
    add_compile_definitions( TARGET_SIMD_ARM=1 )

    # When building for 32-bit Arm platforms with SIMD, unconditionally enable Neon.
    set_if_compiler_supports_flag( FLAG_mfpu_neon -mfpu=neon )
    add_compile_options( ${FLAG_mfpu_neon} )
  else()
    message( STATUS "Arm Neon intrinsics disabled" )
  endif()
endif()

if( VVENC_TARGET_ARCH STREQUAL "LOONGARCH64" )
  if( VVENC_ENABLE_LOONGARCH64_SIMD_LSX )
    set_if_compiler_supports_flag( FLAG_mlsx -mlsx )
    set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAG_mlsx}" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAG_mlsx}" )
    message( STATUS "LoongArch64 LSX intrinsics enabled" )
  else()
    message( STATUS "LoongArch64 LSX intrinsics disabled" )
  endif()
endif()

if( VVENC_ENABLE_ARM_SIMD_SVE )
  include (CheckSymbolExists)

  check_symbol_exists(elf_aux_info "sys/auxv.h" HAVE_AUXV_ELF_AUX_INFO)
  if( HAVE_AUXV_ELF_AUX_INFO )
    add_compile_definitions( HAVE_ELF_AUX_INFO=1 )
  endif()
endif()

if( NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR )
  # set exception handling
  if( MSVC )
    add_compile_options( "/EHsc" )
  endif()

  list( FIND ${PROJECT_NAME}_ADD_SUBDIRECTORIES "source/App/vvencFFapp" vvEncFfAppFound )
  list( FIND ${PROJECT_NAME}_ADD_SUBDIRECTORIES "source/App/vvencapp" vvEncAppFound )

  # vvenc embedded by superproject, always include source/Lib/vvenc  as first component
  list( PREPEND ${PROJECT_NAME}_ADD_SUBDIRECTORIES "source/Lib/vvenc" )
  list( REMOVE_DUPLICATES ${PROJECT_NAME}_ADD_SUBDIRECTORIES )
  message( STATUS "${CMAKE_CURRENT_SOURCE_DIR}: ${PROJECT_NAME} embedded, subdirectories to be added: ${${PROJECT_NAME}_ADD_SUBDIRECTORIES}" )
  # add subdirectories the superproject asked for
  foreach( subdir IN LISTS ${PROJECT_NAME}_ADD_SUBDIRECTORIES )
    add_subdirectory( ${subdir} )
  endforeach()
  return()
endif()

# enable install target
set( VVENC_ENABLE_INSTALL                   ON  CACHE BOOL   "Enable or disable install target" )

set( VVENC_LIBRARY_ONLY                     OFF CACHE BOOL   "Build libvvenc only (no vvencapp,vvencFFapp,vvenclibtest,vvencinterfacetest" )

set( BUILD_SHARED_LIBS                      OFF CACHE BOOL   "Build libvvenc as a shared library" )

# enable postfix
set( VVENC_ENABLE_BUILD_TYPE_POSTFIX        OFF CACHE BOOL   "Enable or disable build type postfix for apps and libs" )

set( VVENC_ENABLE_LINK_TIME_OPT             ON  CACHE BOOL   "Enable link time optimization for release and profile builds" )

set( VVENC_ENABLE_THIRDPARTY_JSON           ON  CACHE STRING "Enable use of thirdparty json library, pass in SYSTEM to rely on an external nlohmann_json" )

set_property( CACHE VVENC_ENABLE_THIRDPARTY_JSON PROPERTY STRINGS OFF SYSTEM ON )

set( VVENC_INSTALL_FULLFEATURE_APP          OFF CACHE BOOL   "Install the full-feature app: vvencFFapp" )

set( VVENC_ENABLE_WERROR                    ON  CACHE BOOL   "Treat warnings as errors (-Werror or /WX)" )

set( VVENC_USE_ADDRESS_SANITIZER            OFF CACHE BOOL   "Enable or disable address sanitizer" )

if( CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
  set( VVENC_OPT_TARGET_ARCH                ""  CACHE STRING "Enable or disable building with architecture specific optimization" )
endif()

if( VVENC_ENABLE_BUILD_TYPE_POSTFIX )
  if( BUILD_SHARED_LIBS )
    # set postfixes for shared libraries
    set( CMAKE_RELEASE_POSTFIX        "-s"   CACHE STRING "Set release library postfix" )
    set( CMAKE_DEBUG_POSTFIX          "-ds"  CACHE STRING "Set debug library postfix" )
    set( CMAKE_RELWITHDEBINFO_POSTFIX "-rds" CACHE STRING "Set relwithdebinfo library postfix" )
    set( CMAKE_MINSIZEREL_POSTFIX     "-mrs" CACHE STRING "Set minsizerel library postfix" )
  else()
    # set postfixes for static libraries
    set( CMAKE_RELEASE_POSTFIX        ""     CACHE STRING "Set release library postfix" )
    set( CMAKE_DEBUG_POSTFIX          "-d"   CACHE STRING "Set debug library postfix" )
    set( CMAKE_RELWITHDEBINFO_POSTFIX "-rd"  CACHE STRING "Set relwithdebinfo library postfix" )
    set( CMAKE_MINSIZEREL_POSTFIX     "-mr"  CACHE STRING "Set minsizerel library postfix" )
  endif()
endif()

# set VVENC_OUTPUT_DIR_POSTFIX
if( BUILD_SHARED_LIBS )
  set( VVENC_OUTPUT_DIR_POSTFIX shared )
else()
  set( VVENC_OUTPUT_DIR_POSTFIX static )
endif()

set( VVENC_ENABLE_TRACING         OFF CACHE BOOL "Set ENABLE_TRACING=1 as a compiler flag" )

set( VVENC_TOPLEVEL_OUTPUT_DIRS   ON  CACHE BOOL   "Put build artifacts into ${CMAKE_SOURCE_DIR}/{bin,lib}/" )

if( VVENC_TOPLEVEL_OUTPUT_DIRS )
  # Using CMake's default library name convention which is the same for all configurations.
  set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG          "${CMAKE_SOURCE_DIR}/lib/debug-${VVENC_OUTPUT_DIR_POSTFIX}" )
  set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE        "${CMAKE_SOURCE_DIR}/lib/release-${VVENC_OUTPUT_DIR_POSTFIX}" )
  set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO "${CMAKE_SOURCE_DIR}/lib/relwithdebinfo-${VVENC_OUTPUT_DIR_POSTFIX}" )
  set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_MINSIZEREL     "${CMAKE_SOURCE_DIR}/lib/minsizerel-${VVENC_OUTPUT_DIR_POSTFIX}" )

  set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG          "${CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG}" )
  set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE        "${CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE}" )
  set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELWITHDEBINFO "${CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELWITHDEBINFO}" )
  set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_MINSIZEREL     "${CMAKE_ARCHIVE_OUTPUT_DIRECTORY_MINSIZEREL}" )

  set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG          "${CMAKE_SOURCE_DIR}/bin/debug-${VVENC_OUTPUT_DIR_POSTFIX}" )
  set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE        "${CMAKE_SOURCE_DIR}/bin/release-${VVENC_OUTPUT_DIR_POSTFIX}" )
  set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO "${CMAKE_SOURCE_DIR}/bin/relwithdebinfo-${VVENC_OUTPUT_DIR_POSTFIX}" )
  set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL     "${CMAKE_SOURCE_DIR}/bin/minsizerel-${VVENC_OUTPUT_DIR_POSTFIX}" )
else()
  # Put build artifacts below build-directory. (Don't need to add {debug,release,relwithdebinfo,minsizerel}-{static,shared}/)
  set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )
  set( CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib" )
  set( CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin" )
endif()

# enable or disable Intel Vtune ITT Tracing
if( CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo" )
    set( VVCEncoderLib_ENABLE_ITT ON CACHE BOOL "Enable Intel Runtime Support for Profiling" )
else()

=== Makefile ===
# VVenC/Makefile
#
# How to build a single target:
#  make <project>-r  => build variant=release
#  make <project>-d  => build variant=debug
#  make <project>-p  => build variant=relwithdebinfo
#
# How to clean and build a single target:
#  make <project>-cr  => clean + build variant=release
#  make <project>-cd  => clean + build variant=debug
#  make <project>-cp  => clean + build variant=relwithdebinfo
#

TARGETS := vvenc vvencapp vvencFFapp

ifneq ($(g),)
ifeq ($(g),umake)
CMAKE_GENERATOR_CUSTOM := Unix Makefiles
else ifeq ($(g),ninja)
CMAKE_GENERATOR_CUSTOM := Ninja
else ifeq ($(g),xcode)
CMAKE_GENERATOR_CUSTOM := Xcode
else
CMAKE_GENERATOR_CUSTOM := $(g)
endif
CONFIG_OPTIONS += -G '$(CMAKE_GENERATOR_CUSTOM)'
endif

ifneq ($(verbose),)
CONFIG_OPTIONS += -DCMAKE_VERBOSE_MAKEFILE=ON
endif

ifneq ($(enable-tracing),)
CONFIG_OPTIONS += -DVVENC_ENABLE_TRACING=$(enable-tracing)
endif

ifneq ($(address-sanitizer),)
CONFIG_OPTIONS += -DVVENC_USE_ADDRESS_SANITIZER=$(address-sanitizer)
endif

ifneq ($(thread-sanitizer),)
CONFIG_OPTIONS += -DVVENC_USE_THREAD_SANITIZER=$(thread-sanitizer)
endif

ifneq ($(enable-arch),)
CONFIG_OPTIONS += -DVVENC_OPT_TARGET_ARCH=$(enable-arch)
endif

ifneq ($(disable-lto),)
CONFIG_OPTIONS += -DVVENC_ENABLE_LINK_TIME_OPT=OFF
endif

ifneq ($(enable-json),)
CONFIG_OPTIONS += -DVVENC_ENABLE_THIRDPARTY_JSON=${enable-json}
endif

ifneq ($(enable-build-type-postfix),)
CONFIG_OPTIONS += -DVVENC_ENABLE_BUILD_TYPE_POSTFIX=ON
endif

ifneq ($(install-prefix),)
CONFIG_OPTIONS += -DCMAKE_INSTALL_PREFIX=$(install-prefix)
endif

ifneq ($(osx-arch),)
CONFIG_OPTIONS += -DCMAKE_OSX_ARCHITECTURES=$(osx-arch)
endif

ifneq ($(toolchainfile),)
CONFIG_OPTIONS += -DCMAKE_TOOLCHAIN_FILE=$(toolchainfile)
endif

ifneq ($(install-ffapp),)
CONFIG_OPTIONS += -DVVENC_INSTALL_FULLFEATURE_APP=$(install-ffapp)
endif

ifneq ($(override-compiler-check),)
CONFIG_OPTIONS += -DVVENC_OVERRIDE_COMPILER_CHECK=$(override-compiler-check)
endif

ifneq ($(enable-werror),)
CONFIG_OPTIONS += -DVVENC_ENABLE_WERROR=$(enable-werror)
endif

ifneq ($(enable-unstable-api),)
CONFIG_OPTIONS += -DVVENC_ENABLE_UNSTABLE_API=$(enable-unstable-api)
endif

ifneq ($(ffp-contract-off),)
CONFIG_OPTIONS += -DVVENC_FFP_CONTRACT_OFF=$(ffp-contract-off)
endif

ifeq ($(j),)
# Query cmake for the number of cores
NUM_JOBS := $(shell cmake -P cmake/modules/vvencNumCores.cmake)
NUM_JOBS := $(lastword $(NUM_JOBS))
else
NUM_JOBS := $(j)
endif

ifeq ($(OS),Windows_NT)
  ifneq ($(msvc-arch),)
    CONFIG_OPTIONS += -A $(msvc-arch)
  else
    CONFIG_OPTIONS += -A x64
  endif
  CMAKE_MCONFIG := 1
  ifneq ($(NUM_JOBS),1)
    BUILD_TOOL_OPTIONS := -- /maxcpucount:$(NUM_JOBS) /verbosity:minimal /nr:false
  else
    BUILD_TOOL_OPTIONS := -- /verbosity:minimal /nr:false
  endif
else
  UNAME_S := $(shell uname -s)
  ifeq ($(UNAME_S),Darwin)
    ifneq ($(CMAKE_GENERATOR_CUSTOM),)
      ifeq ($(CMAKE_GENERATOR_CUSTOM),Xcode)
        CMAKE_MCONFIG := 1
      endif
    else
      # No CMake generator specified as argument. Check for environment first.
      ifeq ($(CMAKE_GENERATOR),)
        CMAKE_MCONFIG := 1
        # Default depends wether ninja is installed or not but this cannot be determined easily.
        CONFIG_OPTIONS += -G Xcode
      else ifeq ($(CMAKE_GENERATOR),Xcode)
        CMAKE_MCONFIG := 1
      endif
    endif
  endif
  ifneq ($(NUM_JOBS),1)
    BUILD_JOBS := -j $(NUM_JOBS)
  endif
endif


ifeq ($(CMAKE_MCONFIG),)
# Using a CMake single-config generater like Unix Makefiles or Ninja
BUILD_DIR-release := build/release-static
BUILD_DIR-debug := build/debug-static
BUILD_DIR-relwithdebinfo := build/relwithdebinfo-static
BUILD_DIR-release-shared := build/release-shared
BUILD_DIR-debug-shared := build/debug-shared
BUILD_DIR-relwithdebinfo-shared := build/relwithdebinfo-shared
else
# Using a CMake multi-config generator like Visual Studio or Xcode
CONFIG_OPTIONS += -DCMAKE_CONFIGURATION_TYPES=Debug\;Release\;RelWithDebInfo

BUILD_DIR_STATIC := build/static
BUILD_DIR_SHARED := build/shared

BUILD_DIR-release := $(BUILD_DIR_STATIC)
BUILD_DIR-debug := $(BUILD_DIR_STATIC)
BUILD_DIR-relwithdebinfo := $(BUILD_DIR_STATIC)
BUILD_DIR-release-shared := $(BUILD_DIR_SHARED)
BUILD_DIR-debug-shared := $(BUILD_DIR_SHARED)
BUILD_DIR-relwithdebinfo-shared := $(BUILD_DIR_SHARED)
endif

BUILD_OPTIONS-release := --build $(BUILD_DIR-release)
BUILD_OPTIONS-debug := --build $(BUILD_DIR-debug)
BUILD_OPTIONS-relwithdebinfo := --build $(BUILD_DIR-relwithdebinfo)
BUILD_OPTIONS-release-shared := --build $(BUILD_DIR-release-shared)
BUILD_OPTIONS-debug-shared := --build $(BUILD_DIR-debug-shared)
BUILD_OPTIONS-relwithdebinfo-shared := --build $(BUILD_DIR-relwithdebinfo-shared)


ifneq ($(CMAKE_MCONFIG),)
BUILD_OPTIONS-release += --config Release
BUILD_OPTIONS-debug += --config Debug
BUILD_OPTIONS-relwithdebinfo += --config RelWithDebInfo
BUILD_OPTIONS-release-shared += --config Release
BUILD_OPTIONS-debug-shared += --config Debug
BUILD_OPTIONS-relwithdebinfo-shared += --config RelWithDebInfo
endif

DEFAULT_BUILD_TARGETS_STATIC := release debug relwithdebinfo
DEFAULT_BUILD_TARGETS_SHARED := $(foreach t,$(DEFAULT_BUILD_TARGETS_STATIC),$(t)-shared)
DEFAULT_BUILD_TARGETS := $(DEFAULT_BUILD_TARGETS_STATIC) $(DEFAULT_BUILD_TARGETS_SHARED)


release: $(BUILD_DIR-release)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-$@) $(BUILD_JOBS) $(BUILD_TOOL_OPTIONS)

debug: $(BUILD_DIR-debug)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-$@) $(BUILD_JOBS) $(BUILD_TOOL_OPTIONS)

relwithdebinfo: $(BUILD_DIR-relwithdebinfo)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-$@) $(BUILD_JOBS) $(BUILD_TOOL_OPTIONS)

release-shared: $(BUILD_DIR-release-shared)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-$@) $(BUILD_JOBS) $(BUILD_TOOL_OPTIONS)

debug-shared: $(BUILD_DIR-debug-shared)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-$@) $(BUILD_JOBS) $(BUILD_TOOL_OPTIONS)

relwithdebinfo-shared: $(BUILD_DIR-relwithdebinfo-shared)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-$@) $(BUILD_JOBS) $(BUILD_TOOL_OPTIONS)

$(foreach t,$(DEFAULT_BUILD_TARGETS),clean-$(t)):
	cmake $(BUILD_OPTIONS-$(patsubst clean-%,%,$@)) $(BUILD_JOBS) --target clean $(BUILD_TOOL_OPTIONS)

install-release: release
	cmake $(BUILD_OPTIONS-$(patsubst install-%,%,$@)) --target install

install-debug: debug
	cmake $(BUILD_OPTIONS-$(patsubst install-%,%,$@)) --target install

install-relwithdebinfo: relwithdebinfo
	cmake $(BUILD_OPTIONS-$(patsubst install-%,%,$@)) --target install

install-release-shared: release-shared
	cmake $(BUILD_OPTIONS-$(patsubst install-%,%,$@)) --target install

install-debug-shared: debug-shared
	cmake $(BUILD_OPTIONS-$(patsubst install-%,%,$@)) --target install

install-relwithdebinfo-shared: relwithdebinfo-shared
	cmake $(BUILD_OPTIONS-$(patsubst install-%,%,$@)) --target install


ifeq ($(CMAKE_MCONFIG),)
$(BUILD_DIR-release)/CMakeCache.txt configure-release:
	cmake -S . -B $(BUILD_DIR-release) $(CONFIG_OPTIONS) -DCMAKE_BUILD_TYPE=Release

$(BUILD_DIR-debug)/CMakeCache.txt configure-debug:
	cmake -S . -B $(BUILD_DIR-debug) $(CONFIG_OPTIONS) -DCMAKE_BUILD_TYPE=Debug

$(BUILD_DIR-relwithdebinfo)/CMakeCache.txt configure-relwithdebinfo:
	cmake -S . -B $(BUILD_DIR-relwithdebinfo) $(CONFIG_OPTIONS) -DCMAKE_BUILD_TYPE=RelWithDebInfo

$(BUILD_DIR-release-shared)/CMakeCache.txt configure-release-shared:
	cmake -S . -B $(BUILD_DIR-release-shared) $(CONFIG_OPTIONS) -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=1

$(BUILD_DIR-debug-shared)/CMakeCache.txt configure-debug-shared:
	cmake -S . -B $(BUILD_DIR-debug-shared) $(CONFIG_OPTIONS) -DCMAKE_BUILD_TYPE=Debug -DBUILD_SHARED_LIBS=1

$(BUILD_DIR-relwithdebinfo-shared)/CMakeCache.txt configure-relwithdebinfo-shared:
	cmake -S . -B $(BUILD_DIR-relwithdebinfo-shared) $(CONFIG_OPTIONS) -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_SHARED_LIBS=1

configure-static: $(foreach t,$(DEFAULT_BUILD_TARGETS_STATIC),configure-$(t))
configure-shared: $(foreach t,$(DEFAULT_BUILD_TARGETS_SHARED),configure-$(t))

else
$(BUILD_DIR_STATIC)/CMakeCache.txt configure-static $(foreach t,$(DEFAULT_BUILD_TARGETS_STATIC),configure-$(t)):
	cmake -S . -B $(BUILD_DIR_STATIC) $(CONFIG_OPTIONS)

$(BUILD_DIR_SHARED)/CMakeCache.txt configure-shared $(foreach t,$(DEFAULT_BUILD_TARGETS_SHARED),configure-$(t)):
	cmake -S . -B $(BUILD_DIR_SHARED) $(CONFIG_OPTIONS) -DBUILD_SHARED_LIBS=1
endif

static: $(DEFAULT_BUILD_TARGETS_STATIC)
shared: $(DEFAULT_BUILD_TARGETS_SHARED)

all: static shared

configure: configure-static configure-shared

install-static: $(foreach t,$(DEFAULT_BUILD_TARGETS_STATIC),install-$(t))
install-shared: $(foreach t,$(DEFAULT_BUILD_TARGETS_SHARED),install-$(t))
install-all: install-static install-shared

# default distribution target
install: install-release-shared

clean:
	$(RM) -rf build bin lib

realclean: clean
	$(RM) -rf install

distclean: realclean
	$(RM) -rf ext


# Some alias targets to ease interactive use in command shells
configure-r: configure-release
configure-d: configure-debug
configure-rs: configure-release-shared
configure-ds: configure-debug-shared
configure-p: configure-relwithdebinfo
configure-ps: configure-relwithdebinfo-shared

clean-r: clean-release
clean-d: clean-debug
clean-rs: clean-release-shared
clean-ds: clean-debug-shared
clean-p: clean-relwithdebinfo
clean-ps: clean-relwithdebinfo-shared

install-r: install-release
install-d: install-debug
install-rs: install-release-shared
install-ds: install-debug-shared
install-p: install-relwithdebinfo
install-ps: install-relwithdebinfo-shared


ifeq ($(CMAKE_MCONFIG),)
TEST_TARGET := test
else
TEST_TARGET := RUN_TESTS
endif

# test target
test: release
	cmake $(BUILD_OPTIONS-release) --target $(TEST_TARGET) $(BUILD_TOOL_OPTIONS)

#
# project specific targets
#

# build the list of release, debug targets given the generic targets
TARGETS_RELEASE := $(foreach t,$(TARGETS),$(t)-r)
TARGETS_DEBUG := $(foreach t,$(TARGETS),$(t)-d)
TARGETS_RELWITHDEBINFO := $(foreach t,$(TARGETS),$(t)-p)

TARGETS_RELEASE_CLEAN_FIRST := $(foreach t,$(TARGETS),$(t)-cr)
TARGETS_DEBUG_CLEAN_FIRST := $(foreach t,$(TARGETS),$(t)-cd)
TARGETS_RELWITHDEBINFO_CLEAN_FIRST := $(foreach t,$(TARGETS),$(t)-cp)

$(TARGETS_RELEASE): $(BUILD_DIR-release)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-release) $(BUILD_JOBS) --target $(patsubst %-r,%,$@) $(BUILD_TOOL_OPTIONS)

$(TARGETS_RELEASE_CLEAN_FIRST): $(BUILD_DIR-release)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-release) $(BUILD_JOBS) --clean-first --target $(patsubst %-cr,%,$@) $(BUILD_TOOL_OPTIONS)

$(TARGETS_DEBUG): $(BUILD_DIR-debug)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-debug) $(BUILD_JOBS) --target $(patsubst %-d,%,$@) $(BUILD_TOOL_OPTIONS)

$(TARGETS_DEBUG_CLEAN_FIRST): $(BUILD_DIR-debug)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-debug) $(BUILD_JOBS) --clean-first --target $(patsubst %-cd,%,$@) $(BUILD_TOOL_OPTIONS)

$(TARGETS_RELWITHDEBINFO): $(BUILD_DIR-relwithdebinfo)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-relwithdebinfo) $(BUILD_JOBS) --target $(patsubst %-p,%,$@) $(BUILD_TOOL_OPTIONS)

$(TARGETS_RELWITHDEBINFO_CLEAN_FIRST): $(BUILD_DIR-relwithdebinfo)/CMakeCache.txt
	cmake $(BUILD_OPTIONS-relwithdebinfo) $(BUILD_JOBS) --clean-first --target $(patsubst %-cp,%,$@) $(BUILD_TOOL_OPTIONS)

.PHONY: install clean realclean distclean

.NOTPARALLEL:

=== test/vvenc_unit_test/CMakeLists.txt ===
# executable
set( EXE_NAME vvenc_unit_test )

# get source files
file( GLOB SRC_FILES CONFIGURE_DEPENDS "*.cpp" )
# get include files
file( GLOB INC_FILES CONFIGURE_DEPENDS "*.h" )

# set resource file for MSVC compilers
if( MSVC )
  set( RESOURCE_FILE ${EXE_NAME}.rc )
endif()

# add executable
add_executable( ${EXE_NAME} ${SRC_FILES} ${INC_FILES} ${RESOURCE_FILE} )
set_target_properties( ${EXE_NAME} PROPERTIES RELEASE_POSTFIX        "${CMAKE_RELEASE_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES DEBUG_POSTFIX          "${CMAKE_DEBUG_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES RELWITHDEBINFO_POSTFIX "${CMAKE_RELWITHDEBINFO_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES MINSIZEREL_POSTFIX     "${CMAKE_MINSIZEREL_POSTFIX}" )
if( VVENC_LIBRARY_ONLY )
  set_target_properties( ${EXE_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE )
endif()

target_compile_options( ${EXE_NAME} PRIVATE $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>>:-Wall>
                                            $<$<CXX_COMPILER_ID:GNU>:-Wall -fdiagnostics-show-option -Wno-ignored-attributes -Wno-sign-compare>

                                            $<$<CXX_COMPILER_ID:MSVC>:/W4 /WX /wd4244 /wd4251 /wd4996>)

target_include_directories( ${EXE_NAME} PRIVATE ${VVENC_LIB_DIR} )
target_link_libraries( ${EXE_NAME} Threads::Threads vvenc )
target_include_directories( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_INCLUDE_DIRECTORIES>> )
target_compile_options( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_OPTIONS>> )
target_compile_definitions( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_DEFINITIONS>> )
# example: place header files in different folders
source_group( "Header Files"   FILES ${INC_FILES} )
source_group( "Resource Files" FILES ${RESOURCE_FILE} )


# set the folder where to place the projects
set_target_properties( ${EXE_NAME}  PROPERTIES FOLDER test )

=== source/App/vvencFFapp/CMakeLists.txt ===
# executable
set( EXE_NAME vvencFFapp )

# get source files
file( GLOB SRC_FILES CONFIGURE_DEPENDS "*.cpp" )

# get include files
file( GLOB INC_FILES CONFIGURE_DEPENDS "*.h" )

# get address sanitizer libs for gcc
if( CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
  if( VVENC_USE_ADDRESS_SANITIZER )
    set( ADDITIONAL_LIBS asan )
  endif()
endif()

# set resource file for MSVC compilers
if( MSVC )
  set( RESOURCE_FILE ${EXE_NAME}.rc )
  file( GLOB NATVIS_FILES CONFIGURE_DEPENDS "../../VisualStudio/*.natvis" )
  # extend the stack size on windows to 2MB
  set( CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} /STACK:0x200000" )
endif()

# add executable
add_executable( ${EXE_NAME} ${SRC_FILES} ${INC_FILES} ${RESOURCE_FILE} )
set_target_properties( ${EXE_NAME} PROPERTIES RELEASE_POSTFIX        "${CMAKE_RELEASE_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES DEBUG_POSTFIX          "${CMAKE_DEBUG_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES RELWITHDEBINFO_POSTFIX "${CMAKE_RELWITHDEBINFO_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES MINSIZEREL_POSTFIX     "${CMAKE_MINSIZEREL_POSTFIX}" )
if( VVENC_LIBRARY_ONLY )
  set_target_properties( ${EXE_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE )
endif()

target_compile_options( ${EXE_NAME} PRIVATE $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>>:-Wall>
                                            $<$<CXX_COMPILER_ID:GNU>:-Wall -fdiagnostics-show-option>
                                            $<$<CXX_COMPILER_ID:MSVC>:/W4 /wd4100 /wd4244 /wd4251 /wd4459 /wd4996>)

target_include_directories( ${EXE_NAME} PRIVATE ../../Lib )
target_link_libraries( ${EXE_NAME} Threads::Threads vvenc )
target_include_directories( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_INCLUDE_DIRECTORIES>> )
target_compile_options( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_OPTIONS>> )
target_compile_definitions( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_DEFINITIONS>> )

# example: place header files in different folders
source_group( "Header Files"   FILES ${INC_FILES} )
source_group( "Resource Files" FILES ${RESOURCE_FILE} )
source_group( "Natvis Files"   FILES ${NATVIS_FILES} )

# set the folder where to place the projects
set_target_properties( ${EXE_NAME}  PROPERTIES FOLDER app )

=== source/App/vvencapp/CMakeLists.txt ===
# executable
set( EXE_NAME vvencapp )

# get source files
file( GLOB SRC_FILES CONFIGURE_DEPENDS "*.cpp" )

# get include files
file( GLOB INC_FILES CONFIGURE_DEPENDS "*.h" )

# get address sanitizer libs for gcc
if( CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
  if( VVENC_USE_ADDRESS_SANITIZER )
    set( ADDITIONAL_LIBS asan )
  endif()
endif()

# set resource file for MSVC compilers
if( MSVC )
  set( RESOURCE_FILE ${EXE_NAME}.rc )
endif()

# add executable
add_executable( ${EXE_NAME} ${SRC_FILES} ${INC_FILES} ${RESOURCE_FILE} )
set_target_properties( ${EXE_NAME} PROPERTIES RELEASE_POSTFIX        "${CMAKE_RELEASE_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES DEBUG_POSTFIX          "${CMAKE_DEBUG_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES RELWITHDEBINFO_POSTFIX "${CMAKE_RELWITHDEBINFO_POSTFIX}" )
set_target_properties( ${EXE_NAME} PROPERTIES MINSIZEREL_POSTFIX     "${CMAKE_MINSIZEREL_POSTFIX}" )
if( VVENC_LIBRARY_ONLY )
  set_target_properties( ${EXE_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE )
endif()

target_compile_options( ${EXE_NAME} PRIVATE $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>>:-Wall>
                                            $<$<CXX_COMPILER_ID:GNU>:-Wall -fdiagnostics-show-option>
                                            $<$<CXX_COMPILER_ID:MSVC>:/W4 /wd4244 /wd4251 /wd4996>)

target_include_directories( ${EXE_NAME} PRIVATE ../../Lib )
target_link_libraries( ${EXE_NAME} Threads::Threads vvenc )
target_include_directories( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_INCLUDE_DIRECTORIES>> )
target_compile_options( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_OPTIONS>> )
target_compile_definitions( ${EXE_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_DEFINITIONS>> )

# example: place header files in different folders
source_group( "Header Files"   FILES ${INC_FILES} )
source_group( "Resource Files" FILES ${RESOURCE_FILE} )


# set the folder where to place the projects
set_target_properties( ${EXE_NAME}  PROPERTIES FOLDER app )

=== source/Lib/vvenc/CMakeLists.txt ===
# library
set( LIB_NAME vvenc )

# create upper case name
string( TOUPPER ${LIB_NAME} LIB_NAME_UC )

# create file version.h
if(PROJECT_VERSION_RC)
  configure_file( version-rc.h.in "${CMAKE_BINARY_DIR}/${LIB_NAME}/version.h" )
else()
  configure_file( version.h.in "${CMAKE_BINARY_DIR}/${LIB_NAME}/version.h" )
endif()

# get source files
file( GLOB BASE_SRC_FILES CONFIGURE_DEPENDS "*.cpp"  "../CommonLib/*.cpp"  "../Utilities/*.cpp" "../DecoderLib/*.cpp" "../EncoderLib/*.cpp" )

# get include files
file( GLOB BASE_INC_FILES CONFIGURE_DEPENDS "*.h" "../CommonLib/*.h"  "../Utilities/*.h" "../DecoderLib/*.h" "../EncoderLib/*.h" "../apputils/*.h" )


if( NOT DEFINED VVENC_ENABLE_X86_SIMD )
  message( FATAL_ERROR "VVENC_ENABLE_X86_SIMD is not defined. Please include TopLevel CMakeLists.txt file of vvenc to set all dependencies!" )
endif()

if( VVENC_ENABLE_X86_SIMD )
  # get x86 source files
  file( GLOB X86_SRC_FILES CONFIGURE_DEPENDS "../CommonLib/x86/*.cpp" )

  # get x86 source files
  file( GLOB X86_INC_FILES CONFIGURE_DEPENDS "../CommonLib/x86/*.h" )

  # get sse4.1 source files
  file( GLOB SSE41_SRC_FILES CONFIGURE_DEPENDS "../CommonLib/x86/sse41/*.cpp" )
  
  # get sse4.2 source files
  file( GLOB SSE42_SRC_FILES CONFIGURE_DEPENDS "../CommonLib/x86/sse42/*.cpp" )
  
  # get avx source files
  file( GLOB AVX_SRC_FILES CONFIGURE_DEPENDS "../CommonLib/x86/avx/*.cpp" )

  if( ${VVENC_TARGET_ARCH} STREQUAL "X86" )
    # get avx2 source files
    file( GLOB AVX2_SRC_FILES CONFIGURE_DEPENDS "../CommonLib/x86/avx2/*.cpp" )
  endif()
endif()

if( VVENC_ENABLE_ARM_SIMD )
  file( GLOB ARM_SRC_FILES CONFIGURE_DEPENDS      "../CommonLib/arm/*.cpp"      )
  file( GLOB ARM_INC_FILES CONFIGURE_DEPENDS      "../CommonLib/arm/*.h"        )

  file( GLOB ARM_NEON_SRC_FILES CONFIGURE_DEPENDS "../CommonLib/arm/neon/*.cpp" )
  file( GLOB ARM_SVE_SRC_FILES  CONFIGURE_DEPENDS "../CommonLib/arm/sve/*.cpp" )
  file( GLOB ARM_SVE2_SRC_FILES CONFIGURE_DEPENDS "../CommonLib/arm/sve2/*.cpp" )
endif()

# get public/extern include files
file( GLOB PUBLIC_INC_FILES CONFIGURE_DEPENDS  "../../../include/${LIB_NAME}/*.h" )

# get all private include files
set( PRIVATE_INC_FILES ${BASE_INC_FILES} ${X86_INC_FILES} ${ARM_INC_FILES} )

# get all source files
set( SRC_FILES ${BASE_SRC_FILES} ${X86_SRC_FILES} ${ARM_SRC_FILES} )
set( INC_FILES ${PRIVATE_INC_FILES} ${PUBLIC_INC_FILES}  )

# NATVIS files for Visual Studio
if( MSVC )
  file( GLOB NATVIS_FILES CONFIGURE_DEPENDS "../../VisualStudio/*.natvis" )

  # example: place header files in different folders
  source_group( "Natvis Files" FILES ${NATVIS_FILES} )
endif()

source_group( "Header Files"          FILES ${PUBLIC_INC_FILES} )
source_group( "Header Files\\private" FILES ${PRIVATE_INC_FILES} )

# set PRIVATE defines for all targets in this directory
add_compile_definitions( ${LIB_NAME_UC}_SOURCE )

# set PRIVATE include directories for all targets in this directory
include_directories( $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../../include> $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}> )
include_directories( . .. ../DecoderLib ../EncoderLib ../CommonLib ../CommonLib/x86 ../CommonLib/arm ../apputils )
include_directories( SYSTEM ../../../thirdparty )

# set common warning flags
add_compile_options( "$<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>>:-Wall;-Wno-deprecated-register;-Wno-unused-const-variable;-Wno-unknown-attributes>" )
add_compile_options( "$<$<CXX_COMPILER_ID:GNU>:-Wall;-Wno-unused-function;;-Wno-unused-variable;-Wno-sign-compare;-fdiagnostics-show-option;-Wno-ignored-attributes>" )
add_compile_options( "$<$<CXX_COMPILER_ID:MSVC>:/W4;/wd4100;/wd4127;/wd4244;/wd4245;/wd4251;/wd4310;/wd4389;/wd4456;/wd4457;/wd4458;/wd4459;/wd4505;/wd4701;/wd4702;/wd4703;/wd4996>" )

# don't export all symbols from shared libraries by default (gcc: -fvisibility=hidden), only those marked as VVENC_DECL
#  behavior similar to __declspec(dllexport) on windows
set( CMAKE_C_VISIBILITY_PRESET hidden )
set( CMAKE_CXX_VISIBILITY_PRESET hidden )

set( CMAKE_VISIBILITY_INLINES_HIDDEN TRUE )

if( VVENC_ENABLE_X86_SIMD )
  # set needed compile definitions
  set_property( SOURCE ${SSE41_SRC_FILES} APPEND PROPERTY COMPILE_DEFINITIONS USE_SSE41 )
  set_property( SOURCE ${SSE42_SRC_FILES} APPEND PROPERTY COMPILE_DEFINITIONS USE_SSE42 )
  set_property( SOURCE ${AVX_SRC_FILES}   APPEND PROPERTY COMPILE_DEFINITIONS USE_AVX )
  set_property( SOURCE ${AVX2_SRC_FILES}  APPEND PROPERTY COMPILE_DEFINITIONS USE_AVX2 )
  # set needed compile flags
  if( MSVC )
    set_property( SOURCE ${AVX_SRC_FILES}   APPEND PROPERTY COMPILE_FLAGS "/arch:AVX" )
    set_property( SOURCE ${AVX2_SRC_FILES}  APPEND PROPERTY COMPILE_FLAGS "/arch:AVX2" )
  elseif( UNIX OR MINGW )
    include( vvencCompilerSupport )

    set_if_compiler_supports_flag( FLAG_mxsave -mxsave  )
    set_if_compiler_supports_flag( FLAG_msse41 -msse4.1 )
    set_if_compiler_supports_flag( FLAG_msse42 -msse4.2 )
    set_if_compiler_supports_flag( FLAG_mavx   -mavx    )
    set_if_compiler_supports_flag( FLAG_mavx2  -mavx2   )

    set_property( SOURCE ${X86_SRC_FILES}   APPEND PROPERTY COMPILE_FLAGS "${FLAG_mxsave}" )
    set_property( SOURCE ${SSE41_SRC_FILES} APPEND PROPERTY COMPILE_FLAGS "${FLAG_msse41}" )
    set_property( SOURCE ${SSE42_SRC_FILES} APPEND PROPERTY COMPILE_FLAGS "${FLAG_msse42}" )
    set_property( SOURCE ${AVX_SRC_FILES}   APPEND PROPERTY COMPILE_FLAGS "${FLAG_mavx}"   )
    set_property( SOURCE ${AVX2_SRC_FILES}  APPEND PROPERTY COMPILE_FLAGS "${FLAG_mavx2}"  )
    
    set_source_files_properties( ../EncoderLib/EncAdaptiveLoopFilter.cpp APPEND PROPERTY COMPILE_FLAGS "${FLAG_msse41}" )
    set_source_files_properties( ../CommonLib/LoopFilter.cpp APPEND PROPERTY COMPILE_FLAGS "${FLAG_msse41}" )
    set_source_files_properties( ../CommonLib/QuantRDOQ2.cpp APPEND PROPERTY COMPILE_FLAGS "${FLAG_msse41}" )
  endif()

  add_library( ${LIB_NAME}_x86_simd OBJECT ${SSE41_SRC_FILES} ${SSE42_SRC_FILES} ${AVX_SRC_FILES} ${AVX2_SRC_FILES} )

  # Disble LTO for the files compiled with special architecture flags.
  set_target_properties( ${LIB_NAME}_x86_simd PROPERTIES
                                              INTERPROCEDURAL_OPTIMIZATION                OFF
                                              INTERPROCEDURAL_OPTIMIZATION_RELEASE        OFF
                                              INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO OFF
                                              INTERPROCEDURAL_OPTIMIZATION_MINSIZEREL     OFF )

  set_target_properties( ${LIB_NAME}_x86_simd PROPERTIES FOLDER lib )

  target_include_directories( ${LIB_NAME}_x86_simd PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_INCLUDE_DIRECTORIES>> )
  target_compile_options( ${LIB_NAME}_x86_simd PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_OPTIONS>> )
  target_compile_definitions( ${LIB_NAME}_x86_simd PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_DEFINITIONS>> )
endif()

if( VVENC_ENABLE_ARM_SIMD )
  # Set needed compile definitions.
  set_property( SOURCE ${ARM_NEON_SRC_FILES} APPEND PROPERTY COMPILE_DEFINITIONS USE_NEON )

  if(( ${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm64" ) OR ( ${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64" ))
    # Neon is mandatory in AArch64, so no additional compile flags needed here.
  else()
    set_if_compiler_supports_flag( FLAG_mfpu_neon "-mfpu=neon" )
    set_property( SOURCE ${ARM_NEON_SRC_FILES} APPEND PROPERTY COMPILE_FLAGS "${FLAG_mfpu_neon}" )
  endif()
  list( APPEND ARM_SIMD_SRC_FILES ${ARM_NEON_SRC_FILES} )

  if( VVENC_ENABLE_ARM_SIMD_SVE )
    set_property( SOURCE ${ARM_SVE_SRC_FILES} APPEND PROPERTY COMPILE_DEFINITIONS USE_NEON USE_SVE )
    set_property( SOURCE ${ARM_SVE_SRC_FILES} APPEND PROPERTY COMPILE_FLAGS ${FLAG_sve} )
    list( APPEND ARM_SIMD_SRC_FILES ${ARM_SVE_SRC_FILES} )
  endif()

  if( VVENC_ENABLE_ARM_SIMD_SVE2 )
    set_property( SOURCE ${ARM_SVE2_SRC_FILES} APPEND PROPERTY COMPILE_DEFINITIONS USE_NEON USE_SVE USE_SVE2 )
    set_property( SOURCE ${ARM_SVE2_SRC_FILES} APPEND PROPERTY COMPILE_FLAGS ${FLAG_sve2} )
    list( APPEND ARM_SIMD_SRC_FILES ${ARM_SVE2_SRC_FILES} )
  endif()

  add_library( ${LIB_NAME}_arm_simd OBJECT ${ARM_SIMD_SRC_FILES} )

  # Disable LTO for the files compiled with special architecture flags.
  set_target_properties( ${LIB_NAME}_arm_simd PROPERTIES
                                              INTERPROCEDURAL_OPTIMIZATION                OFF
                                              INTERPROCEDURAL_OPTIMIZATION_RELEASE        OFF
                                              INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO OFF
                                              INTERPROCEDURAL_OPTIMIZATION_MINSIZEREL     OFF )

  set_target_properties( ${LIB_NAME}_arm_simd PROPERTIES FOLDER lib )

  target_include_directories( ${LIB_NAME}_arm_simd PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_INCLUDE_DIRECTORIES>> )
  target_compile_options( ${LIB_NAME}_arm_simd PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_OPTIONS>> )
  target_compile_definitions( ${LIB_NAME}_arm_simd PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_DEFINITIONS>> )
endif()

# set resource file for MSVC compilers
if( MSVC )
  set( RESOURCE_FILE ${LIB_NAME}.rc )
endif()

add_library( ${LIB_NAME} ${SRC_FILES} $<$<TARGET_EXISTS:${LIB_NAME}_x86_simd>:$<TARGET_OBJECTS:${LIB_NAME}_x86_simd>> $<$<TARGET_EXISTS:${LIB_NAME}_arm_simd>:$<TARGET_OBJECTS:${LIB_NAME}_arm_simd>> ${INC_FILES} ${NATVIS_FILES} ${RESOURCE_FILE} )

target_compile_definitions( ${LIB_NAME} PUBLIC $<$<STREQUAL:$<TARGET_PROPERTY:${LIB_NAME},TYPE>,SHARED_LIBRARY>:${LIB_NAME_UC}_DYN_LINK> )

target_include_directories( ${LIB_NAME} SYSTEM INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../../include> $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}> )

if( CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0 )
  target_compile_options( ${LIB_NAME} PRIVATE $<$<CXX_COMPILER_ID:GNU>: -Wno-array-bounds> )
endif()

target_include_directories( ${LIB_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_INCLUDE_DIRECTORIES>> )
target_compile_options( ${LIB_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_OPTIONS>> )
target_compile_definitions( ${LIB_NAME} PRIVATE $<$<TARGET_EXISTS:nlohmann_json::nlohmann_json>:$<TARGET_PROPERTY:nlohmann_json::nlohmann_json,INTERFACE_COMPILE_DEFINITIONS>> )

if( TARGET INTEL_ITT)
  target_link_libraries( ${LIB_NAME} PRIVATE INTEL_ITT Threads::Threads )
else()
  target_link_libraries( ${LIB_NAME} PRIVATE Threads::Threads )
endif()

if( CMAKE_USE_PTHREADS_INIT )
  target_compile_definitions( ${LIB_NAME} PRIVATE HAVE_PTHREADS )
endif()

# set the folder where to place the projects
set_target_properties( ${LIB_NAME} PROPERTIES
                                   VERSION ${PROJECT_VERSION}
                                   SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
                                   INSTALL_NAME_DIR ${CMAKE_INSTALL_PREFIX}/lib
                                   MACOSX_RPATH FALSE
                                   FOLDER lib )

=== debian/changelog ===
vvenc-dmo (1.14.0-dmo2) unstable; urgency=medium

  * Add nlohmann-json3-dev to Build-Depends and enable tests.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 21 Jan 2026 15:46:29 +0100

vvenc-dmo (1.14.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 21 Jan 2026 14:47:16 +0100

=== debian/control ===
Source: vvenc-dmo
Section: video
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/fraunhoferhhi/vvenc/releases
Standards-Version: 4.7.3
Build-Depends: debhelper-compat (= 13), cmake (>= 3.13.0~), ninja-build,
 nlohmann-json3-dev, quilt,

Package: vvenc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: Fraunhofer Versatile Video Encoder (VVenC)
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and is published by ITU-T as H.266 and by ISO/IEC as MPEG-I
 Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate reduction
 over HEVC at the same visual quality. In addition, VVC proves to be truly
 versatile by including tools for efficient coding of video content in
 emerging applications, e.g. high dynamic range (HDR), adaptive streaming,
 computer generated content as well as immersive applications like 360-degree
 video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Encoder (VVenC) is a fast and efficient
 "real-world" VVC encoder implementation with the following main features:
 .
  * Easy to use encoder implementation with five predefined quality/speed
    presets;
  * Perceptual optimization to improve subjective video quality, based on
    the XPSNR visual model;
  * Frame-level single-pass and two-pass rate control supporting variable
    bit-rate (VBR) encoding;
  * Expert mode encoder interface available, allowing fine-grained control
    of the encoding proces.

Package: libvvenc1.14
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: Fraunhofer Versatile Video Encoder - runtime files.
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and is published by ITU-T as H.266 and by ISO/IEC as MPEG-I
 Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate reduction
 over HEVC at the same visual quality. In addition, VVC proves to be truly
 versatile by including tools for efficient coding of video content in
 emerging applications, e.g. high dynamic range (HDR), adaptive streaming,
 computer generated content as well as immersive applications like 360-degree
 video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Encoder (VVenC) is a fast and efficient
 "real-world" VVC encoder implementation with the following main features:
 .
  * Easy to use encoder implementation with five predefined quality/speed
    presets;
  * Perceptual optimization to improve subjective video quality, based on
    the XPSNR visual model;
  * Frame-level single-pass and two-pass rate control supporting variable
    bit-rate (VBR) encoding;
  * Expert mode encoder interface available, allowing fine-grained control
    of the encoding proces.
 .
 This package contains the shared library.

Package: libvvenc-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libvvenc1.14 (= ${binary:Version}), ${misc:Depends},
Description: Fraunhofer Versatile Video Encoder - devel files.
 Versatile Video Coding (VVC) is the most recent international video coding
 standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
 Video Coding Experts Group (VCEG) and the ISO/IEC Moving Picture Experts
 Group (MPEG). VVC is the successor of the High Efficiency Video Coding
 (HEVC) standard and is published by ITU-T as H.266 and by ISO/IEC as MPEG-I
 Part 3 (ISO/IEC 23090-3). The new standard targets a 50% bit-rate reduction
 over HEVC at the same visual quality. In addition, VVC proves to be truly
 versatile by including tools for efficient coding of video content in
 emerging applications, e.g. high dynamic range (HDR), adaptive streaming,
 computer generated content as well as immersive applications like 360-degree
 video and augmented reality (AR).
 .
 The Fraunhofer Versatile Video Encoder (VVenC) is a fast and efficient
 "real-world" VVC encoder implementation with the following main features:
 .
  * Easy to use encoder implementation with five predefined quality/speed
    presets;
  * Perceptual optimization to improve subjective video quality, based on
    the XPSNR visual model;
  * Frame-level single-pass and two-pass rate control supporting variable
    bit-rate (VBR) encoding;
  * Expert mode encoder interface available, allowing fine-grained control
    of the encoding proces.
 .
 This package contains headers and a static library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_SKIP_INSTALL_RPATH=ON \
	-DVVENC_ENABLE_INSTALL=ON \
	-DVVENC_ENABLE_LINK_TIME_OPT=ON \
	-DVVENC_ENABLE_THIRDPARTY_JSON=SYSTEM \
	-DVVENC_ENABLE_WERROR=OFF

#	exit 1

override_dh_clean:
	dh_clean

	rm -rf bin
	rm -rf lib

#override_dh_auto_test:
